<?php
include_once( ITE_PI_PATH . 'includes/products.php' );

include_once( ITE_PI_PATH . 'includes/categories.php' );
include_once( ITE_PI_PATH . 'includes/tags.php' );

if( is_admin() ) {

	/* Start of: WordPress Administration */

	function it_exchange_product_importer_import_init() {

		global $import, $wpdb;

		$troubleshooting_url = 'http://www.visser.com.au/documentation/product-importer-deluxe/usage/';

		// Notice to increase WordPress memory allocation
		if( !it_exchange_product_importer_get_option( 'memory_notice', 0 ) ) {
			$memory_limit = (int)( ini_get( 'memory_limit' ) );
			$minimum_memory_limit = 64;
			if( $memory_limit < $minimum_memory_limit ) {
				$memory_url = add_query_arg( array( 'page' => 'it-exchange-product-importer', 'action' => 'dismiss-memory' ), 'admin.php' );
				$message = sprintf( __( 'We recommend setting memory to at least %dMB prior to importing, your site has only %dMB allocated to it. See <a href="%s" target="_blank">Increasing memory allocated to PHP</a> for more information.<span style="float:right;"><a href="%s">Dismiss</a></span>', 'exchange-addon-importer' ), $minimum_memory_limit, $memory_limit, $troubleshooting_url, $memory_url );
				it_exchange_product_importer_admin_notice( $message, 'error' );
			}
		}

		// Notice to install/open Store Exporter
		if( !it_exchange_product_importer_get_option( 'exporter_notice', false ) ) {
			$it_exchange_message = ' ';
			if( function_exists( 'it_exchange_exporter_admin_init' ) ) {
				$it_exchange_url = add_query_arg( 'page', 'it-exchange-exporter', 'admin.php' );
				$it_exchange_message .= sprintf( __( 'Jump over to <a href="%s">Store Exporter</a>.', 'exchange-addon-importer' ), $it_exchange_url );
			} else {
				$it_exchange_url = 'http://www.visser.com.au/exchange/plugins/exporter/';
				$it_exchange_message .= sprintf( __( 'Install our free <a href="%s" target="_blank">Store Exporter add-on</a>.', 'exchange-addon-importer' ), $it_exchange_url );
			}
			$message = __( 'Would you like to export an initial CSV file of your existing iThemes Exchange Products which you can adjust and re-import with Product Importer?', 'exchange-addon-importer' ) . $it_exchange_message;
			$dismiss_url = add_query_arg( array( 'page' => 'it-exchange-product-importer', 'action' => 'dismiss-exporter' ), 'admin.php' );
			$dismiss_link = sprintf( '<span style="float:right;"><a href="%s">Dismiss</a></span>', $dismiss_url );
			it_exchange_product_importer_admin_notice( $message . $dismiss_link );
		}

		// Notice to install Add Product SKU
		if( !it_exchange_product_importer_get_option( 'sku_notice', false ) && !it_exchange_product_type_supports_feature( 'simple-product-type', 'sku' ) ) {
			$it_exchange_url = 'http://wordpress.org/plugins/exchange-addon-add-product-sku/';
			$it_exchange_message = sprintf( ' ' . __( 'Install our free <a href="%s" target="_blank">Add Product SKU add-on</a>.', 'exchange-addon-importer' ), $it_exchange_url );
			$message = __( 'Before importing new Products we recommend you add SKU support to your Products so you can merge and/or delete Products based on their unique SKU.', 'exchange-addon-importer' ) . $it_exchange_message;
			$dismiss_url = add_query_arg( array( 'page' => 'it-exchange-product-importer', 'action' => 'dismiss-add-sku' ), 'admin.php' );
			$dismiss_link = sprintf( '<span style="float:right;"><a href="%s">Dismiss</a></span>', $dismiss_url );
			it_exchange_product_importer_admin_notice( $message . $dismiss_link );
		}

		$wpdb->hide_errors();
		@ini_set( 'memory_limit', WP_MAX_MEMORY_LIMIT );

		$action = it_exchange_get_action();
		switch( $action ) {

			case 'save-settings':
				it_exchange_product_importer_update_option( 'delete_csv', ( isset( $_POST['delete_temporary_csv'] ) ? $_POST['delete_temporary_csv'] : 0 ) );
				it_exchange_product_importer_update_option( 'encoding', ( isset( $_POST['encoding'] ) ? $_POST['encoding'] : 'UTF-8' ) );
				it_exchange_product_importer_update_option( 'timeout', ( isset( $_POST['timeout'] ) ? $_POST['timeout'] : 0 ) );
				it_exchange_product_importer_update_option( 'delimiter', ( isset( $_POST['delimiter'] ) ? $_POST['delimiter'] : ',' ) );
				it_exchange_product_importer_update_option( 'category_separator', ( isset( $_POST['category_separator'] ) ? $_POST['category_separator'] : '|' ) );
				it_exchange_product_importer_update_option( 'parent_child_delimiter', ( isset( $_POST['parent_child_delimiter'] ) ? $_POST['parent_child_delimiter'] : '>' ) );

				$message = __( 'Settings saved.', 'exchange-addon-importer' );
				it_exchange_product_importer_admin_notice( $message );
				break;

			default:
				it_exchange_product_importer_update_option( 'csv', '' );
				$import = new stdClass;
				$import->upload_method = it_exchange_product_importer_get_option( 'upload_method', 'upload' );
				$import->delimiter = it_exchange_product_importer_get_option( 'delimiter', ',' );
				$import->category_separator = it_exchange_product_importer_get_option( 'category_separator', '|' );
				$import->parent_child_delimiter = it_exchange_product_importer_get_option( 'parent_child_delimiter', '>' );
				$import->delete_temporary_csv = it_exchange_product_importer_get_option( 'delete_csv', 0 );
				break;

			case 'upload':
				$import = new stdClass;
				$import->cancel_import = false;
				$import->skip_first = false;
				$import->import_method = it_exchange_product_importer_get_option( 'import_method', 'new' );
				$import->default_product_type = it_exchange_product_importer_get_option( 'default_product_type', 'simple-product-type' );
				$import->advanced_log = it_exchange_product_importer_get_option( 'advanced_log', 1 );
				$import->delimiter = ( isset( $_POST['delimiter'] ) ? $_POST['delimiter'] : ',' );
				$import->category_separator = ( isset( $_POST['category_separator'] ) ? $_POST['category_separator'] : '|' );
				$import->parent_child_delimiter = ( isset( $_POST['parent_child_delimiter'] ) ? $_POST['parent_child_delimiter'] : '>' );
				$import->delete_temporary_csv = it_exchange_product_importer_get_option( 'delete_csv', 0 );
				$import->timeout = it_exchange_product_importer_get_option( 'timeout', 600 );
				$import->upload_mb = wp_max_upload_size();
				it_exchange_product_importer_update_option( 'delimiter', $import->delimiter );
				it_exchange_product_importer_update_option( 'category_separator', $import->category_separator );
				it_exchange_product_importer_update_option( 'parent_child_delimiter', $import->parent_child_delimiter );

				// Capture the CSV file uploaded
				if( !empty( $_FILES['csv_file']['name'] ) ) {
					$file = $_FILES['csv_file'];
				} else {
					$file = array(
						'size' => 0
					);
				}

				// Validation of the import method chosen and uploaded file
				if( isset( $file['error'] ) && $file['size'] == 0 ) {
					// User has uploaded the CSV file but it has expired, usually due to PHP timeout or completed import
					$import->cancel_import = true;
					$message = sprintf( __( 'Your CSV file upload has expired, re-upload it from the opening import screen. <a href="%s" target="_blank">Need help?</a>', 'exchange-addon-importer' ), $troubleshooting_url );
					it_exchange_product_importer_admin_notice( $message, 'error' );
				} else if( strpos( strtolower( $file['name'] ), 'csv' ) == false ) {
					// Not a CSV file or lacking a *.csv file extension
					$import->cancel_import = true;
					$message = sprintf( __( 'Product Importer Deluxe requires a CSV-formatted upload, if you are sure the file is a CSV please change the file extension and re-upload. <a href="%s" target="_blank">Need help?</a>', 'exchange-addon-importer' ), $troubleshooting_url );
					it_exchange_product_importer_admin_notice( $message, 'error' );
				} else if( $file['size'] == 0 && empty( $file['name'] ) ) {
					// No file uploaded
					$import->cancel_import = true;
					$message = sprintf( __( 'No CSV file was uploaded. Please select a CSV to upload from the \'Choose File\' dialog or other available upload options, alternatively select a CSV from Past Imports. <a href="%s" target="_blank">Need help?</a>', 'exchange-addon-importer' ), $troubleshooting_url );
					it_exchange_product_importer_admin_notice( $message, 'error' );
				}

				// Validation of the WordPress site and memory allocation against the uploaded file
				if( $file['size'] > $import->upload_mb ) {
					$import->cancel_import = true;
					$message = sprintf( __( 'The file you\'re importing exceeded the maximum allowed filesize (see Maximum size), increase the file upload limit or import a smaller CSV file. <a href="%s" target="_blank">Need help?</a>', 'exchange-addon-importer' ), $troubleshooting_url );
					it_exchange_product_importer_admin_notice( $message, 'error' );
				}
				if( $import->delimiter == '' || $import->category_separator == '' ) {
					$import->cancel_import = true;
					$message = sprintf( __( 'You cannot leave the Field delimiter or Product Category separator options under Import Options empty. <a href="%s" target="_blank">Need help?</a>', 'exchange-addon-importer' ), $troubleshooting_url );
					it_exchange_product_importer_admin_notice( $message, 'error' );
				}

				if( !$import->cancel_import ) {
					$upload = wp_upload_bits( $file['name'], null, file_get_contents( $file['tmp_name'] ) );
					if( $upload['error'] ) {
						$import->cancel_import = true;
						$message = sprintf( __( 'There was an error while uploading your CSV file, \'%s\'. %s', 'exchange-addon-importer' ), $upload['error'], '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'exchange-addon-importer' ) . '</a>' );
						it_exchange_product_importer_admin_notice( $message, 'error' );
					}
					it_exchange_product_importer_update_option( 'csv', $upload['file'] );
					$import->file = $file;
				}

				break;

			case 'save':

				global $product;

				$import = new stdClass;
				$import->cancel_import = false;
				$import->log = '';
				$import->delimiter = it_exchange_product_importer_get_option( 'delimiter', ',' );
				$import->category_separator = it_exchange_product_importer_get_option( 'category_separator', '|' );
				$import->parent_child_delimiter = it_exchange_product_importer_get_option( 'parent_child_delimiter', '>' );
				$import->delete_temporary_csv = it_exchange_product_importer_get_option( 'delete_csv', 0 );
				$import->skip_first = ( isset( $_POST['skip_first'] ) ? $_POST['skip_first'] : false );
				it_exchange_product_importer_update_option( 'import_method', ( isset( $_POST['import_method'] ) ? $_POST['import_method'] : 'new' ) );
				it_exchange_product_importer_update_option( 'default_product_type', ( isset( $_POST['default_product_type'] ) ? $_POST['default_product_type'] : 'simple-product-type' ) );
				it_exchange_product_importer_update_option( 'advanced_log', ( isset( $_POST['advanced_log'] ) ? 1 : 0 ) );
				if( isset( $_POST['timeout'] ) )
					it_exchange_product_importer_update_option( 'timeout', $_POST['timeout'] );

				if( !it_exchange_product_importer_get_option( 'csv' ) ) {
					$import->cancel_import = true;
					$troubleshooting_url = 'http://www.visser.com.au/woocommerce/documentation/plugins/product-importer-deluxe/usage/';
					$message = sprintf( __( 'Your CSV file upload has expired, re-upload it from the opening import screen. %s', 'exchange-addon-importer' ), '<a href="' . $troubleshooting_url . '" target="_blank">' . __( 'Need help?', 'exchange-addon-importer' ) . '</a>' );
					it_exchange_product_importer_admin_notice( $message, 'error' );
				}

				if( $import->cancel_import )
					continue;

				if ( isset( $_POST['refresh_step'] ) ) {
					$step = $_POST['refresh_step'];
					$settings = array(
						'restart_from' => ( isset( $_POST['restart_from'] ) ? $_POST['restart_from'] : 0 ),
						'progress' => ( isset( $_POST['progress'] ) ? $_POST['progress'] : 0 ),
						'total_progress' => ( isset( $_POST['total_progress'] ) ? $_POST['total_progress'] : 0 )
					);
				} else {
					$step = 'prepare_data';
					$settings = $_POST;
				}

				wp_enqueue_script( 'jquery' );
				wp_enqueue_script( 'progressBar', plugins_url( '/js/progress.js', ITE_PI_FILE ), array( 'jquery' ) );
				wp_enqueue_script( 'ajaxUpload', plugins_url( '/js/ajaxupload.js', ITE_PI_FILE ), array( 'jquery' ) );
				wp_register_script( 'ajaxImporter', plugins_url( '/js/engine.js', ITE_PI_FILE ), array( 'jquery' ) );
				wp_enqueue_script( 'ajaxImporter' );
				wp_localize_script( 'ajaxImporter', 'ajaxImport', array(
					'settings'	=> $settings,
					'ajaxurl'	=> admin_url( 'admin-ajax.php' ),
					'step'		=> $step
				) );

				break;

		}

	}

	function it_exchange_product_importer_ajax_product_importer() {

		if( isset( $_POST['step'] ) ) {

			global $import;

			@ini_set( 'memory_limit', WP_MAX_MEMORY_LIMIT );

			ob_start();

			$import = new stdClass;
			if( $_POST['step'] != 'prepare_data' ) {
				$import = get_transient( 'it_exchange_product_importer_import' );
				if( is_object( $import ) ) {
					foreach( $_POST['settings'] as $key => $value ) {
						if( is_array( $value ) ) {
							foreach( $value as $value_key => $value_value )
								if( !is_array( $value_value ) )
									$value[$value_key] = stripslashes( $value_value );
							$import->$key = $value;
						} else {
							$import->$key = stripslashes( $value );
						}
					}
				} else {
					$import = new stdClass;
					$import->cancel_import = true;
					$import->failed_import = array();
					$troubleshooting_url = 'http://www.visser.com.au/woocommerce/documentation/plugins/product-importer-deluxe/usage/';
					$import->failed_import[] = sprintf( __( 'Your CSV contained special characters that WordPress and Product Importer Deluxe could not filter. %s', 'exchange-addon-importer' ), __( 'Need help?', 'exchange-addon-importer' ) . ' ' . $troubleshooting_url );
				}
			}

			$timeout = 0;
			if( isset( $import->timeout ) )
				$timeout = $import->timeout;

			if( !ini_get( 'safe_mode' ) )
				@set_time_limit( $timeout );

			switch ( $_POST['step'] ) {

				case 'prepare_data':
					$import = new stdClass;
					$import->start_time = time();
					$import->cancel_import = false;
					$import->log = '';
					$import->timeout = ( isset( $_POST['timeout'] ) ? $_POST['timeout'] : false );
					$import->delimiter = $_POST['delimiter'];
					$import->category_separator = $_POST['category_separator'];
					$import->parent_child_delimiter = $_POST['parent_child_delimiter'];
					$import->delete_temporary_csv = it_exchange_product_importer_get_option( 'delete_csv', 0 );
					$import->import_method = ( isset( $_POST['import_method'] ) ? $_POST['import_method'] : 'new' );
					$import->default_product_type = ( isset( $_POST['default_product_type'] ) ? $_POST['default_product_type'] : 'simple-product-type' );
					$import->advanced_log = ( isset( $_POST['advanced_log'] ) ? $_POST['advanced_log'] : '' );
					$import->log .= '<br />' . sprintf( __( 'Import method: %s', 'exchange-addon-importer' ), $import->import_method );
					$import->log .= '<br />' . sprintf( __( 'Default product type: %s', 'exchange-addon-importer' ), $import->default_product_type );
					it_exchange_product_importer_prepare_data();
					if( !$import->cancel_import )
						it_exchange_product_importer_prepare_columns();
					$import->skip_first = $_POST['skip_first'];
					$import->log .= "<br />" . __( 'Product columns have been grouped', 'exchange-addon-importer' );

					$import->log .= "<br /><br />" . __( 'Generating Categories...', 'exchange-addon-importer' );
					$import->loading_text = __( 'Generating Categories...', 'exchange-addon-importer' );
					break;

				case 'generate_categories':
					$import->products_added = 0;
					$import->products_deleted = 0;
					$import->products_failed = 0;
					// Category generation
					$term_taxonomy = 'it_exchange_category';
					if( $import->import_method == 'new' && taxonomy_exists( $term_taxonomy ) && isset( $import->csv_category ) )
						it_exchange_product_importer_generate_categories();
					else
						$import->log .= "<br />" . __( 'Categories skipped', 'exchange-addon-importer' );
					$import->log .= "<br /><br />" . __( 'Generating Tags...', 'exchange-addon-importer' );
					$import->loading_text = __( 'Generating Tags...', 'exchange-addon-importer' );
					break;

				case 'generate_tags':
					// Tag generation
					$term_taxonomy = 'it_exchange_tag';
					if( $import->import_method == 'new' && taxonomy_exists( $term_taxonomy ) && isset( $import->csv_tag ) )
						it_exchange_product_importer_generate_tags();
					else
						$import->log .= "<br />" . __( 'Tags skipped', 'exchange-addon-importer' );
					if( $import->import_method == 'new' ) {
						$import->log .= "<br /><br />" . __( 'Generating Products...', 'exchange-addon-importer' );
					} else if( $import->import_method == 'delete' ) {
						$import->log .= "<br /><br />" . __( 'Checking for matching Products to delete...', 'exchange-addon-importer' );
					}
					$import->loading_text = __( 'Importing Products...', 'exchange-addon-importer' );
					break;

				case 'prepare_product_import':

					global $import, $product;

					if( $import->advanced_log )
						$import->log .= "<br />>>> " . __( 'Including non-essential reporting in this import log', 'exchange-addon-importer' );
					if( $import->skip_first ) {
						$import->i = 1;
						$import->log .= "<br />>>> " . __( 'Skipping import of first CSV row', 'exchange-addon-importer' );
					} else {
						$import->i = 0;
						$import->log .= "<br />>>> " . __( 'Starting import at first CSV row', 'exchange-addon-importer' );
					}
					$i = $import->i;
					it_exchange_product_importer_prepare_product( $i );

					// This runs once as part of the import preparation
					$import->active_product = $product;
					if( $import->import_method == 'new' ) {
						if( !empty( $product->product_title ) )
							$import->log .= "<br />>>> " . sprintf( __( 'Importing %s...', 'exchange-addon-importer' ), $product->product_title );
						else
							$import->log .= "<br />>>> " . sprintf( __( 'Importing (no title) - SKU: %s...', 'exchange-addon-importer' ), $product->sku );
					} else if( $import->import_method == 'delete' ) {
						if( !empty( $product->product_title ) )
							$import->log .= "<br />>>> " . sprintf( __( 'Searching for %s...', 'exchange-addon-importer' ), $product->product_title );
						else
							$import->log .= "<br />>>> " . sprintf( __( 'Searching for (no title) - SKU: %s...', 'exchange-addon-importer' ), $product->sku );
					}
					$import->loading_text = sprintf( __( 'Importing Product %1$d of %2$d...', 'exchange-addon-importer' ), $i, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
					break;

				case 'save_product':

					global $import, $product;

					$i = $_POST['i'];

					if( $import->active_product ) {
						if( !isset( $product ) )
							$product = new stdClass;
						foreach( $import->active_product as $key => $value )
							$product->$key = $value;
					}

					$import->product_start_time = microtime( true );

					if( $import->import_method == 'new' ) {
						// Build Categories
						it_exchange_product_importer_process_categories();

						// Build Tags
						it_exchange_product_importer_process_tags();
					}

					// Check for duplicate SKU
					it_exchange_product_importer_duplicate_product_exists();

					it_exchange_product_importer_validate_product();

					if( $product->fail_requirements ) {

						if( $import->advanced_log )
							$import->log .= "<br />>>>>>> " . __( 'Skipping Product, see Import Report for more information', 'exchange-addon-importer' );
						else
							$import->log .= "<br />>>>>>> " . __( 'Skipping Product', 'exchange-addon-importer' );
						$import->products_failed++;

					} else {

						if( $import->import_method == 'new' && !$product->duplicate_exists ) {
							it_exchange_product_importer_create_product();
						} else if( $import->import_method == 'delete' && $product->duplicate_exists ) {
							it_exchange_product_importer_delete_product();
						}

						if( $product->skipped ) {
							if( $import->advanced_log )
								$import->log .= "<br />>>>>>> " . __( 'Skipping Product, see Import Report for more information', 'exchange-addon-importer' );
							else
								$import->log .= "<br />>>>>>> " . __( 'Skipping Product', 'exchange-addon-importer' );
							$import->products_failed++;
						} else {
							if( $import->import_method == 'new' ) {
								if( !empty( $product->product_title ) )
									$import->log .= "<br />>>>>>> " . sprintf( __( '%s successfully imported', 'exchange-addon-importer' ), $product->product_title );
								else
									$import->log .= "<br />>>>>>> " . sprintf( __( '(no title) - SKU: %s successfully imported', 'exchange-addon-importer' ), $product->sku );
							} else if( $import->import_method == 'delete' ) {
								if( !empty( $product->product_title ) )
									$import->log .= "<br />>>>>>> " . sprintf( __( '%s successfully deleted', 'exchange-addon-importer' ), $product->product_title );
								else
									$import->log .= "<br />>>>>>> " . sprintf( __( '(no title) - SKU: %s successfully deleted', 'exchange-addon-importer' ), $product->sku );
							}
						}
					}
					$import->product_end_time = microtime( true );
					$import->product_min_time = ( isset( $import->product_min_time ) ? $import->product_min_time : ( $import->product_end_time - $import->product_start_time ) );
					$import->product_max_time = ( isset( $import->product_max_time ) ? $import->product_max_time : ( $import->product_end_time - $import->product_start_time ) );
					// Update minimum product import time if it is shorter than the last
					if( ( $import->product_end_time - $import->product_start_time ) < $import->product_min_time )
						$import->product_min_time = ( $import->product_end_time - $import->product_start_time );
					// Update maximum product import time if it is longer than the last
					if( ( $import->product_end_time - $import->product_start_time ) > $import->product_max_time )
						$import->product_max_time = ( $import->product_end_time - $import->product_start_time );

					if( $i+1 == $import->rows ) {
						if( $import->import_method == 'new' )
							$import->log .= "<br />" . __( 'Products have been generated', 'exchange-addon-importer' );
						else if( $import->import_method == 'delete' )
							$import->log .= "<br />" . __( 'Products have been deleted', 'exchange-addon-importer' );
						$import->log .= "<br /><br />" . __( 'Cleaning up...', 'exchange-addon-importer' );
						$import->loading_text = __( 'Cleaning up...', 'exchange-addon-importer' );
					} else {
						unset( $import->active_product );

						it_exchange_product_importer_prepare_product( $i + 1 );

						// This runs for each additional Product imported
						$import->active_product = $product;
						if( $import->import_method == 'new' ) {
							if( !empty( $product->product_title ) )
								$import->log .= "<br />>>> " . sprintf( __( 'Importing %s...', 'exchange-addon-importer' ), $product->product_title );
							else
								$import->log .= "<br />>>> " . sprintf( __( 'Importing (no title) - SKU: %s...', 'exchange-addon-importer' ), $product->sku );
							$import->loading_text = sprintf( __( 'Importing Product %1$d of %2$d...', 'exchange-addon-importer' ), $i + 1, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
						} else if( $import->import_method == 'delete' ) {
							if( !empty( $product->product_title ) )
								$import->log .= "<br />>>> " . sprintf( __( 'Searching for %s...', 'exchange-addon-importer' ), $product->product_title );
							else
								$import->log .= "<br />>>> " . sprintf( __( 'Searching for (no title) - SKU: %s...', 'exchange-addon-importer' ), $product->sku );
							$import->loading_text = sprintf( __( 'Searching for Product %1$d of %2$d...', 'exchange-addon-importer' ), $i + 1, ( $import->skip_first ? $import->rows - 1 : $import->rows ) );
						}
					}
					break;

				case 'clean_up':

					global $wpdb, $product;

					$import->log .= "<br />" . __( 'Clean up has completed', 'exchange-addon-importer' );

					$import->end_time = time();
					if( $import->advanced_log ) {
						$import->log .= "<br /><br />" . __( 'Import summary', 'exchange-addon-importer' );
						if( $import->import_method == 'new' )
							$import->log .= "<br />>>> " . sprintf( __( '%d Products added', 'exchange-addon-importer' ), $import->products_added );
						else if( $import->import_method == 'delete' )
							$import->log .= "<br />>>> " . sprintf( __( '%d Products deleted', 'exchange-addon-importer' ), $import->products_deleted );
						$import->log .= "<br />>>> " . sprintf( __( '%d Products skipped', 'exchange-addon-importer' ), $import->products_failed );
						$import->log .= "<br />>>> " . sprintf( __( 'Import took %s to complete', 'exchange-addon-importer' ), it_exchange_product_importer_display_time_elapsed( $import->start_time, $import->end_time ) );
						$import->log .= "<br />>>> " . sprintf( __( 'Fastest Product took less than %s to process', 'exchange-addon-importer' ), it_exchange_product_importer_display_time_elapsed( time(), strtotime( sprintf( '+%d seconds', $import->product_min_time ) ) ) );
						$import->log .= "<br />>>> " . sprintf( __( 'Slowest Product took more than %s to process', 'exchange-addon-importer' ), it_exchange_product_importer_display_time_elapsed( time(), strtotime( sprintf( '+%d seconds', $import->product_max_time ) ) ) );
					}

					$import->log .= "<br /><br />" . __( 'Import complete!', 'exchange-addon-importer' );
					$import->loading_text = __( 'Completed', 'exchange-addon-importer' );
					break;

			}

			$import->step = $_POST['step'];
			$import->errors = ob_get_clean();

			set_transient( 'it_exchange_product_importer_import', $import );

			$return = array();
			if( isset( $import->log ) )
				$return['log'] = $import->log;
			if( isset( $import->rows ) )
				$return['rows'] = $import->rows;
			if( isset( $import->loading_text ) )
				$return['loading_text'] = $import->loading_text;
			if( isset( $import->cancel_import ) )
				$return['cancel_import'] = $import->cancel_import;
			if( isset( $import->failed_import ) )
				$return['failed_import'] = $import->failed_import;
			if( isset( $i ) )
				$return['i'] = $i;
			if( isset( $import->next ) )
				$return['next'] = $import->next;
			if( isset( $import->html ) )
				$return['html'] = $import->html;
			if( isset( $import->step ) )
				$return['step'] = $import->step;

			array_map( 'utf8_encode', $return );

			header( "Content-type: application/json" );
			echo json_encode( $return );
		}
		die();

	}
	add_action( 'wp_ajax_product_importer', 'it_exchange_product_importer_ajax_product_importer' );

	function it_exchange_product_importer_ajax_finish_import() {

		global $import;

		$return = array();

		ob_start();

		$import = new stdClass;
		$import = get_transient( 'it_exchange_product_importer_import' );
		foreach( $_POST['settings'] as $key => $value ) {
			if( is_array( $value ) ) {
				foreach( $value as $value_key => $value_value )
					if( !is_array( $value_value ) ) $value[$value_key] = stripslashes( $value_value );
				$import->$key = $value;
			} else {
				$import->$key = stripslashes( $value );
			}
		}
		$return['next'] = 'finish-import';
		$post_type = 'product';
		$manage_products_url = add_query_arg( 'post_type', $post_type, 'edit.php' );
		delete_transient( 'it_exchange_product_importer_import' );
		// Terminate import session if Products were imported/merged
		it_exchange_product_importer_delete_csv();
		include_once( ITE_PI_PATH . 'templates/admin/import_finish.php' );

		$return['html'] = ob_get_clean();
		header( "Content-type: application/json" );
		echo json_encode( $return );

		die();

	}
	add_action( 'wp_ajax_finish_import', 'it_exchange_product_importer_ajax_finish_import' );

	function it_exchange_product_importer_finish_message() {

		global $import;

		$message = '';
		if( !$import->failed_products ) {
			if( $import->import_method == 'new' ) {
				$message = apply_filters( 'it_exchange_product_importer_finish_success_import', __( 'Good news! All of your Products have been successfully imported into Exchange.', 'exchange-addon-importer' ) );
			} else if( $import->import_method == 'delete' ) {
				$message = apply_filters( 'it_exchange_product_importer_finish_success_delete', __( 'Good news! All of your matched Products have been successfully deleted from Exchange.', 'exchange-addon-importer' ) );
			}
		} else {
			if( $import->products_added || $import->products_deleted ) {
				if( $import->import_method == 'new' )
					$message = apply_filters( 'it_exchange_product_importer_finish_partial_import', __( 'Here\'s the news. Some of your Products have been successfully imported into Exchange.', 'exchange-addon-importer' ) );
				else if( $import->import_method == 'merge' )
					$message = apply_filters( 'it_exchange_product_importer_finish_partial_delete', __( 'Here\'s the news. Some of your Products have been successfully removed from Exchange.', 'exchange-addon-importer' ) );
			} else {
				if( $import->import_method == 'new' )
					$message = apply_filters( 'it_exchange_product_importer_finish_fail_import', __( 'Here\'s the news. No new Products were imported into Exchange.', 'exchange-addon-importer' ) );
				else if( $import->import_method == 'delete' )
					$message = apply_filters( 'it_exchange_product_importer_finish_fail_delete', __( 'Here\'s the news. No matched Products were removed from Exchange.', 'exchange-addon-importer' ) );
			}
		}
		if( $message ) { ?>
<div class="updated settings-error below-h2">
	<p><?php echo $message; ?></p>
</div>
<?php
		}

	}

	/* End of: WordPress Administration */

}

function it_exchange_product_importer_prepare_data() {

	global $import;

	if( $file = it_exchange_product_importer_get_option( 'csv' ) ) {
		ini_set( 'auto_detect_line_endings', true );
		if( @filesize( $file ) > 0 ) {
			if( $handle = @fopen( $file, 'r' ) ) {
				$import->lines = array();
				$line = 0;
				while( ( $buffer = fgets( $handle ) ) !== false ) {
					if( $line == 0 )
						$import->lines[0] = it_exchange_product_importer_encode_transient( $buffer );
					if( $line == 1 ) {
						$import->lines[1] = it_exchange_product_importer_encode_transient( $buffer );
						break;
					}
					$line++;
				}
				fclose( $handle );
			}
			if( $handle = @fopen( $file, 'r' ) ) {
				$data = array();
				while( ( $csv_data = @fgetcsv( $handle, filesize( $handle ), $import->delimiter ) ) !== false ) {
					$size = count( $csv_data );
					for( $i = 0; $i < $size; $i++ ) {
						if( !isset( $data[$i] ) || !is_array( $data[$i] ) )
							$data[$i] = array();
						$csv_data[$i] = trim( $csv_data[$i] );
						array_push( $data[$i], $csv_data[$i] );
					}
					unset( $csv_data );
				}
				fclose( $handle );
				$import->csv_data = $data;
				unset( $csv_data, $data );
				if( $import->advanced_log )
					$import->log .= "<br />" . __( 'Sufficient memory is available...', 'exchange-addon-importer' );
			} else {
				$import->cancel_import = true;
				$import->failed_import[] = __( 'Could not read file.', 'exchange-addon-importer' );
			}
		} else {
			$import->cancel_import = true;
			$import->failed_import[] = __( 'Could not read file.', 'exchange-addon-importer' );
		}
		unset( $handle );
	} else {
		$import->cancel_import = true;
		$import->failed_import[] = __( 'Could not read file.', 'exchange-addon-importer' );
	}

}

function it_exchange_product_importer_prepare_columns_filter( $var = null ) {

	// $var = htmlspecialchars( $var, ENT_QUOTES );
	$var = filter_var( $var, FILTER_SANITIZE_ENCODED );
	return $var;

}

function it_exchange_product_importer_filter_set_transient( $var ) {

	if( is_object( $var ) ) {
		foreach( $var as $key => $value )
			$var->$key = it_exchange_product_importer_encode_transient( $value );
	}
	return $var;

}
add_filter( 'pre_set_transient_it_exchange_product_importer_import', 'it_exchange_product_importer_filter_set_transient' );

function it_exchange_product_importer_encode_transient( $var = null ) {

	// Check that the Encoding class by Sebastin Grignoli exists
	if( file_exists( ITE_PI_PATH . 'classes/Encoding.php' ) ) {
		include_once( ITE_PI_PATH . 'classes/Encoding.php' );
		$encoding = new Encoding();
		return $encoding::toUTF8( $var );
	} else {
		return $var;
	}

}

function it_exchange_product_importer_format_column( $column ) {

	$output = $column;
	$output = strtolower( $output );
	$output = str_replace( array( ' ', ' - ' ), '_', $output );
	return $output;

}

function it_exchange_product_importer_search_column( $option = array(), $cell = '' ) {

	$column = it_exchange_product_importer_format_column( $option['name'] );
	// Check if the alias key exists
	if( isset( $option['alias'] ) ) {
		// Check if the cell name is within the alias list
		$key = array_search( $cell, $option['alias'] );
		if( $key !== false )
			$column = $option['alias'][$key];
	}
	return $column;

}

function it_exchange_product_importer_prepare_columns( $value_data = array() ) {

	global $import;

	if( !$value_data )
		$value_data = $_POST['value_name'];
	if( $value_data ) {
		$csv_data = array();
		foreach( $value_data as $key => $value ) {
			if( isset( $import->csv_data[$key] ) )
				$csv_data[$value] = $import->csv_data[$key];
		}
	}
	unset( $import->csv_data );

	if( it_exchange_product_importer_validate_columns( $csv_data ) )
		$import->cancel_import = true;
	else
		$import->log .= "<br />" . __( 'Sufficient data was provided, beginning import...', 'exchange-addon-importer' );

	$import->log .= "<br /><br />" . __( 'Detect and group Product columns...', 'exchange-addon-importer' );

	$import->rows = 0;
	if( isset( $csv_data['sku'] ) ) {
		$import->csv_sku = array_filter( $csv_data['sku'] );
		$import->rows = count( $import->csv_sku );
		$import->log .= "<br />>>> " . __( 'SKU has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['product_title'] ) ) {
		$import->csv_product_title = array_filter( $csv_data['product_title'] );
		array_walk_recursive( $import->csv_product_title, 'it_exchange_product_importer_prepare_columns_filter' );
		$import->rows = count( $import->csv_product_title );
		$import->log .= "<br />>>> " . __( 'Product Title has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['description'] ) ) {
		$import->csv_description = array_filter( $csv_data['description'] );
		array_walk_recursive( $import->csv_description, 'it_exchange_product_importer_prepare_columns_filter' );
		$import->log .= "<br />>>> " . __( 'Description has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['extended_description'] ) ) {
		$import->csv_extended_description = array_filter( $csv_data['extended_description'] );
		array_walk_recursive( $import->csv_extended_description, 'it_exchange_product_importer_prepare_columns_filter' );
		$import->log .= "<br />>>> " . __( 'Extended Description has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['product_type'] ) ) {
		$import->csv_product_type = array_filter( $csv_data['product_type'] );
		$import->log .= "<br />>>> " . __( 'Product Type has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['visibility'] ) ) {
		$import->csv_visibility = array_filter( $csv_data['visibility'] );
		$import->log .= "<br />>>> " . __( 'Visibility has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['price'] ) ) {
		// Accept empty/null values for this field
		$import->csv_price = array_filter( $csv_data['price'] );
		$import->log .= "<br />>>> " . __( 'Price has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['category'] ) ) {
		$import->csv_category = array_filter( $csv_data['category'] );
		$import->log .= "<br />>>> " . __( 'Category has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['tag'] ) ) {
		$import->csv_tag = array_filter( $csv_data['tag'] );
		$import->log .= "<br />>>> " . __( 'Tag has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['inventory'] ) ) {
		$import->csv_inventory = array_filter( $csv_data['inventory'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Inventory has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['purchase_message'] ) ) {
		$import->csv_purchase_message = array_filter( $csv_data['purchase_message'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Purchase Message has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['status'] ) ) {
		$import->csv_status = array_filter( $csv_data['status'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Product Status has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['store_order'] ) ) {
		$import->csv_store_order = array_filter( $csv_data['store_order'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Store Order has been detected and grouped', 'exchange-addon-importer' );
	}
	if( isset( $csv_data['slug'] ) ) {
		$import->csv_slug = array_filter( $csv_data['slug'], 'strlen' );
		$import->log .= "<br />>>> " . __( 'Slug has been detected and grouped', 'exchange-addon-importer' );
	}

}

function it_exchange_product_importer_validate_columns( $csv_data ) {

	global $import;

	$status = false;
	// Create new Product - Requires Product Title or SKU
	if( ( !isset( $csv_data['product_title'] ) || !isset( $csv_data['sku'] ) ) && !isset( $csv_data['category'] ) )
		$status = true;
	if( $status ) {
		$failed_reason = array();
		// Create new Product
		if( !isset( $csv_data['category'] ) )
			$failed_reason[] = __( 'No Category was provided', 'exchange-addon-importer' );
		if( !$failed_reason )
			$failed_reason[] = __( 'No specific reason was given, raise this as a Support issue', 'exchange-addon-importer' );
		if( $failed_reason ) {
			$size = ( count( $failed_reason ) - 1 );
			for( $i = 0; $i <= $size; $i++ ) {
				if( $failed_reason[$i] )
					$import->failed_import[] = $failed_reason[$i];
			}
		}
	}
	return $status;

}

function it_exchange_product_importer_upload_directories() {

	global $import;

	$upload_dir = wp_upload_dir();
	$import->uploads_directory = $upload_dir['path'] . '/';
	$import->uploads_url = $upload_dir['baseurl'] . '/';
	if( $use_yearmonth_folders = get_option( 'uploads_use_yearmonth_folders' ) )
		$import->date_directory = date( 'Y/m/', strtotime( current_time( 'mysql' ) ) );

}

function it_exchange_product_importer_force_update_post( $post_id = 0, $column = '', $value = '' ) {

	global $wpdb;

	if( $post_id && !empty( $column ) ) {
		$wpdb->show_errors = true;
		$response = $wpdb->update( $wpdb->posts, array(
			($column) => $value
		), array( 'ID' => $post_id ), array(
			'%s'
		) );
		if( $response !== false )
			return true;
	}

}

// Deletes the temporary CSV file used at import time
function it_exchange_product_importer_delete_csv() {

	global $import;

	switch( $import->delete_temporary_csv ) {

		case '1':
			// Delete CSV from /wp-content/uploads/
			if( $file = it_exchange_product_importer_get_option( 'csv' ) ) {
				if( file_exists( $file ) )
					@unlink( $file );
			}
			if( $import->advanced_log )
				$import->log .= "<br /><br />" . __( 'Temporary CSV deleted', 'exchange-addon-importer' );
			break;

		case '0':
		default:
			// Add CSV to Past Imports
/*
			if( $file = it_exchange_product_importer_get_option( 'csv' ) )
				it_exchange_product_importer_add_past_import( $file );
*/
			break;

	}

}

function it_exchange_product_importer_display_time_elapsed( $from = 0, $to = 0, $output = '-' ) {

	if( $from && $to ) {
		$output = __( '1 second', 'exchange-addon-importer' );
		$time = $to - $from;
		$tokens = array (
			31536000 => __( 'year', 'exchange-addon-importer' ),
			2592000 => __( 'month', 'exchange-addon-importer' ),
			604800 => __( 'week', 'exchange-addon-importer' ),
			86400 => __( 'day', 'exchange-addon-importer' ),
			3600 => __( 'hour', 'exchange-addon-importer' ),
			60 => __( 'minute', 'exchange-addon-importer' ),
			1 => __( 'second', 'exchange-addon-importer' )
		);
		foreach ($tokens as $unit => $text) {
			if ($time < $unit) continue;
			$numberOfUnits = floor($time / $unit);
			$output = $numberOfUnits . ' ' . $text . ( ( $numberOfUnits > 1 ) ? 's' : '' );
		}
	}
	return $output;

}

function it_exchange_product_importer_get_option( $option = null, $default = false, $allow_empty = false ) {

	$output = '';
	if( isset( $option ) ) {
		if( $storage = get_option( 'it-storage-exchange_addon_product-importer', array() ) )
			$output = ( isset( $storage[$option] ) ? $storage[$option] : $default );
		if( $allow_empty == false && $output == '' )
			$output = $default;
		if( $allow_empty == false && $output != 0 && ( $output == false || $output == '' ) )
			$output = $default;
	}
	return $output;

}

function it_exchange_product_importer_update_option( $option = null, $value = null ) {

	$output = false;
	if( isset( $option ) && isset( $value ) ) {
		$storage = (array)get_option( 'it-storage-exchange_addon_product-importer', array() );
		$storage[$option] = $value;
		$output = update_option( 'it-storage-exchange_addon_product-importer', $storage );
	}
	return $output;

}
?>